/* Copyright 2017 Beetroot design group, beetroot.gr

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), 
to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, 
and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, 
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */
 
 
#targetengine "session09";
var doc =app.activeDocument;  


var myScriptPath = (File(app.activeScript.fullName).parent.fsName).toString().replace(/\\/g, '/') + "/Res/";
var w = new Window("palette", "FlowType 1.0 public - beetroot.gr");
w.orientation = "column";

var sGroup = w.add("group");
var img1 = sGroup.add("image", undefined, File(myScriptPath + "1.png"));
var isizeV = sGroup.add('edittext {text: 24, characters: 4, justify: "center", active: true}');
isizeV.onChange = function () {
	if (Number(isizeV.text) <= 1)
		isizeV.text = "1";
}
var sizeS = sGroup.add('slider {minvalue: 0.5, maxvalue: 96, value: 24}');
sizeS.onChanging = function () {
	sizeV.text = sizeS.value;
}
sizeS.enabled = false;
var sizeV = sGroup.add('edittext {text: 24, characters: 4, justify: "center", active: true}');
sizeV.onChange = function () {
	if (Number(sizeV.text) <= 1)
		sizeV.text = "1";
}
sizeBox = sGroup.add("checkbox", undefined, "");
sizeBox.size = [14, 14];
sizeBox.value = true;

var blGroup = w.add("group");
var img2 = blGroup.add("image", undefined, File(myScriptPath + "2.png"));
var ibaseLineV = blGroup.add('edittext {text: 0, characters: 4, justify: "center", active: true}');
var baseLineS = blGroup.add('slider {minvalue: -100, maxvalue: 100, value: 0}');
baseLineS.onChanging = function () {
	baseLineV.text = baseLineS.value;
}
var baseLineV = blGroup.add('edittext {text: 0, characters: 4, justify: "center", active: true}');
baseBox = blGroup.add("checkbox", undefined, "");
baseBox.size = [14, 14];
baseBox.value = true;

var trackingGroup = w.add("group");
var img3 = trackingGroup.add("image", undefined, File(myScriptPath + "4.png"));
var itrackingV = trackingGroup.add('edittext {text: 0, characters: 4, justify: "center", active: true}');
var trackingS = trackingGroup.add('slider {minvalue: -100, maxvalue: 100, value: 0}');
trackingS.onChanging = function () {
	trackingV.text = trackingS.value;
}
var trackingV = trackingGroup.add('edittext {text: 0, characters: 4, justify: "center", active: true}');
trackingBox = trackingGroup.add("checkbox", undefined, "");
trackingBox.size = [14, 14];
trackingBox.value = true;

var hSizeGroup = w.add("group");
var img4 = hSizeGroup.add("image", undefined, File(myScriptPath + "5.png"));
var ihSizeV = hSizeGroup.add('edittext {text: 100, characters: 4, justify: "center", active: true}');
ihSizeV.onChange = function () {
	if (Number(ihSizeV.text) <= 1)
		ihSizeV.text = "1";
}
var hSizeS = hSizeGroup.add('slider {minvalue: 1, maxvalue: 500, value: 100}');
hSizeS.onChanging = function () {
	hSizeV.text = hSizeS.value;
}
var hSizeV = hSizeGroup.add('edittext {text: 100, characters: 4, justify: "center", active: true}');
hSizeV.onChange = function () {
	if (Number(hSizeV.text) <= 1)
		hSizeV.text = "1";
}
hSizeBox = hSizeGroup.add("checkbox", undefined, "");
hSizeBox.size = [14, 14];
hSizeBox.value = true;

var vSizeGroup = w.add("group");
var img7 = vSizeGroup.add("image", undefined, File(myScriptPath + "8.png"));
var ivSizeV = vSizeGroup.add('edittext {text: 100, characters: 4, justify: "center", active: true}');
ivSizeV.onChange = function () {
	if (Number(ivSizeV.text) <= 1)
		ivSizeV.text = "1";
}
var vSizeS = vSizeGroup.add('slider {minvalue: 1, maxvalue: 500, value: 100}');
vSizeS.onChanging = function () {
	vSizeV.text = vSizeS.value;
}
var vSizeV = vSizeGroup.add('edittext {text: 100, characters: 4, justify: "center", active: true}');
vSizeV.onChange = function () {
	if (Number(vSizeV.text) <= 1)
		vSizeV.text = "1";
}
vSizeBox = vSizeGroup.add("checkbox", undefined, "");
vSizeBox.size = [14, 14];
vSizeBox.value = true;

var skewGroup = w.add("group");
var img5 = skewGroup.add("image", undefined, File(myScriptPath + "3.png"));
var iskewV = skewGroup.add('edittext {text: 0, characters: 4, justify: "center", active: true}');
iskewV.enabled = false;
var skewS = skewGroup.add('slider {minvalue: 0, maxvalue: 85, value: 0}');
skewS.onChanging = function () {
	skewV.text = skewS.value;
}
var skewV = skewGroup.add('edittext {text: 0, characters: 4, justify: "center", active: true}');
skewV.onChange = function () {
	if (Number(skewV.text) >= 85)
		skewV.text = "85";
}
skewBox = skewGroup.add("checkbox", undefined, "");
skewBox.size = [14, 14];
skewBox.value = true;

w.separator = w.add("panel");
w.separator.alignment = 'fill';

var mfGroup = w.add("group");
var img5 = mfGroup.add("image", undefined, File(myScriptPath + "6.png"));
var mfS = mfGroup.add('slider {minvalue: 0.1, maxvalue: 50, value: 0}');
mfS.onChanging = function () {
	mfV.text = mfS.value;
}
var mfV = mfGroup.add('edittext {text: 1, characters: 4, justify: "center", active: true}');
mfV.onChange = function () {
	if (Number(mfV.text) <= 0.1)
		mfV.text = "0.1";
}

var mfOffsetGroup = w.add("group");
var img6 = mfOffsetGroup.add("image", undefined, File(myScriptPath + "7.png"));
var mfOffsetS = mfOffsetGroup.add('slider {minvalue: 0.1, maxvalue: 50, value: 0}');
mfOffsetS.onChanging = function () {
	mfOffsetV.text = mfOffsetS.value;
}
var mfOffsetV = mfOffsetGroup.add('edittext {text: 0, characters: 4, justify: "center", active: true}');

w.separator = w.add("panel");
w.separator.alignment = 'fill';

var btnsGrp = w.add("group");

var btnsBtn = btnsGrp.add('button {text: "R"}');
var lineBtn = btnsGrp.add('button {text: "Line"}');
var curveBtn = btnsGrp.add('button {text: "Curve"}');
btnsBtn.alignment = 'fill';
btnsBtn.onClick = function () {
	//myparams = [false];
	app.doScript(resetText, undefined, undefined, UndoModes.entireScript);
}
lineBtn.onClick = function () {
	myparams = [false];
	app.doScript(execute, undefined, myparams, UndoModes.entireScript);
}
curveBtn.onClick = function () {
	myparams = [true];
	app.doScript(execute, undefined, myparams, UndoModes.entireScript);
}

function execute(r) {
	if (app.selection[0]instanceof Text || app.selection[0]instanceof TextFrame || app.selection[0]instanceof Word || app.selection[0]instanceof Paragraph) {
		var tf = app.selection[0];
		var totalChars = tf.characters.count();
		var _size = Number(sizeV.text);
		var i_size = Number(isizeV.text);
		var _baseLine = Number(baseLineV.text);
		var _tracking = Number(trackingV.text);
		var i_tracking = Number(itrackingV.text);
		var _hSize = Number(hSizeV.text);
		var i_hSize = Number(ihSizeV.text);
		var _vSize = Number(vSizeV.text);
		var i_vSize = Number(ivSizeV.text);
		var _skew = Number(skewV.text);
		var _mf = Number(mfV.text);
		var _mfOffset = Number(mfOffsetV.text);

		var step = _mf * (Math.PI) / (totalChars - 1);
		var stepLinear = _mf / (totalChars - 1);

		var pb = new Window('palette');
		pb.pbar = pb.add('progressbar', undefined, 0, totalChars);
		pb.pbar.preferredSize.width = 300;

		if (r[0]) {
			for (var n = 0; n < totalChars; n++) {
				pb.show();
				pb.pbar.value = n + 1;
				pb.update();
				var activeChar = n;
				var c = tf.characters[activeChar];
				var cos = (Math.cos(n * step + Math.PI + (_mfOffset * (Math.PI / 2))) + 1) / 2
				var cosSkew = Math.cos(n * step + Math.PI + (_mfOffset * (Math.PI / 2)));
				if (baseBox.value)
					c.baselineShift = cos * _baseLine;
				if (sizeBox.value)
					c.pointSize = cos * (_size - i_size) + i_size;
				if (trackingBox.value)
					c.tracking = cos * (_tracking - i_tracking) + i_tracking;
				if (hSizeBox.value)
					c.horizontalScale = (_hSize - i_hSize) >= 0 ? i_hSize + (_hSize - i_hSize) * cos : i_hSize - (i_hSize - _hSize) * cos;
				if (vSizeBox.value)
					c.verticalScale = (_vSize - i_vSize) >= 0 ? i_vSize + (_vSize - i_vSize) * cos : i_vSize - (i_vSize - _vSize) * cos;
				if (skewBox.value)
					c.skew = cosSkew * _skew;
			}
		} else {
			for (var n = 0; n < totalChars; n++) {
				pb.show();
				pb.pbar.value = n + 1;
				pb.update();
				var activeChar = n;
				var c = tf.characters[activeChar];
				var cos = Math.abs(1 - Math.abs(((n * stepLinear + (_mfOffset / 2) + 1) % 4) - 2));
				var cosSkew = Math.cos(n * step + Math.PI + (_mfOffset * (Math.PI / 2)));
				if (baseBox.value)
					c.baselineShift = cos * _baseLine;
				if (sizeBox.value)
					c.pointSize = cos * (_size - i_size) + i_size;
				if (trackingBox.value)
					c.tracking = cos * (_tracking - i_tracking) + i_tracking;
				if (hSizeBox.value)
					c.horizontalScale = (_hSize - i_hSize) >= 0 ? i_hSize + (_hSize - i_hSize) * cos : i_hSize - (i_hSize - _hSize) * cos;
				if (vSizeBox.value)
					c.verticalScale = (_vSize - i_vSize) >= 0 ? i_vSize + (_vSize - i_vSize) * cos : i_vSize - (i_vSize - _vSize) * cos;
				if (skewBox.value)
					c.skew = cosSkew * _skew;
			}
		}
		pb.close();
	} else {
		alert("Please select either a textframe or a text part")
	}
}

function resetText() {
	if (app.selection[0]instanceof Text || app.selection[0]instanceof TextFrame || app.selection[0]instanceof Word || app.selection[0]instanceof Paragraph) {
		var tf = app.selection[0];
		for (var n = 0; n < tf.characters.length; n++) {
			var c = tf.characters[n];
			c.skew = 0;
			c.horizontalScale = 100;
			c.pointSize = tf.characters[0].pointSize;
			c.baselineShift = 0;
			c.tracking = 0;
			c.characterRotation = 0;
			c.verticalScale = 100;
		};
	} else {
		alert("Please select either a textframe or a text part")
	}
}

function pick(val) {
	//alert(app.selection[0]);
	if (app.selection[0]instanceof Text || app.selection[0]instanceof TextFrame || app.selection[0]instanceof Word || app.selection[0]instanceof Paragraph) {
		var tf = app.selection[0];
		var c = tf.characters[0];
		val.text = c.pointSize;
	}
	if (app.selection[0]instanceof InsertionPoint) {
		var ip = app.selection[0];
		val.text = ip.pointSize;
	}
}

function changeUnitsToPixels() {
	if (typeof originalUnitsH === 'undefined')
		originalUnitsH = app.documents[0].viewPreferences.horizontalMeasurementUnits;
	if (typeof originalUnitsV === 'undefined')
		originalUnitsV = app.documents[0].viewPreferences.verticalMeasurementUnits;
	app.documents[0].viewPreferences.horizontalMeasurementUnits = app.documents[0].viewPreferences.verticalMeasurementUnits = MeasurementUnits.pixels;
}

function changeUnitsBack() {
	app.documents[0].viewPreferences.horizontalMeasurementUnits = originalUnitsH;
	app.documents[0].viewPreferences.verticalMeasurementUnits = originalUnitsV;
	delete originalUnitsH;
	delete originalUnitsV;
}

function rand(min, max) {
	return Math.random() * (max - min + 1) + min;
}

w.show();
